/*
 * JBoss, Home of Professional Open Source.
 * See the COPYRIGHT.txt file distributed with this work for information
 * regarding copyright ownership.  Some portions may be licensed
 * to Red Hat, Inc. under one or more contributor license agreements.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 * Modified by
 * @author  Data Virtuality GmbH
 * @date    $Date: 2015-04-21 12:34:10 +0300 (Tue, 21 Apr 2015) $
 *  
 */

package org.teiid.translator.jdbc.postgresql;

import org.teiid.translator.jdbc.oracle.AbstractFormatFunctionModifier;

import java.util.regex.Pattern;

public class PostgresFormatFunctionModifier extends AbstractFormatFunctionModifier {

	public PostgresFormatFunctionModifier(String prefix) {
		super(prefix);
	}

	@Override
	public Pattern getTokenPattern() {
		return Pattern.compile("(G|y{1,4}|M{1,4}|D{1,3}|d{1,2}|E{1,4}|a{1,2}|H{1,2}|h{1,2}|m{1,2}|s{1,2}|S{1,3}|Z|z{3}|[\\- /,.;:]+|(?:'[^'\"]*')+|[^'\"a-zA-Z]+)"); //$NON-NLS-1$
	}

	@Override
	protected String getMillisecondsPattern(String group) {
		return "MS";
	}

	protected Object convertToken(String group) {
		if (group.charAt(0) == 'z') {
			return "zzz";
		}
		else {
			return super.convertToken(group);
		}
	}
}